/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.JenisProduk;
import com.portofolio.entity.vo.JenisProdukId;

@Lazy
@Repository("jenisProdukDao")
public interface JenisProdukDao extends CrudRepository<JenisProduk, JenisProdukId> {

	@Query(QListAll)
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);

	@Query(QListAll + " and model.namaJenisProduk like %:namaJenisProduk% ")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("namaJenisProduk") String namaJenisProduk, @Param("statusEnabled") boolean statusEnabled,Pageable page);

	@Query(QListAll + " and model.id.kdJenisProduk = :kdJenisProduk")
	Map<String, Object> findByKdJenisProduk(@Param("kdProfile") Integer kdProfile,@Param("kdJenisProduk") Integer kdJenisProduk, @Param("statusEnabled") boolean statusEnabled);

	String QListAll = "select new map(model.id.kdJenisProduk as kdJenisProduk,model.id.kdProfile as kdProfile "
			+ ", model.namaJenisProduk as namaJenisProduk " + ", model.reportDisplay as reportDisplay "
			+ ", model.kdJenisProdukHead as kdJenisProdukHead "
			+ ", jenisProdukHead.namaJenisProduk as namaPangakatHead " + ", model.kodeExternal as kodeExternal "
			+ ", model.namaExternal as namaExternal  "
			+ ", model.statusEnabled as statusEnabled " + ", model.noRec as noRec,model.version as version )"
			+ " from JenisProduk model left join model.id id " + " left join model.jenisProdukHead jenisProdukHead "
			+ "  where id.kdProfile=:kdProfile and model.statusEnabled =:statusEnabled ";

}
